
; HL..HL+BC-1 = src
; DE = dst

decompressRLE:
        xor   a
        ld    (.l4 + 1), a
        jr    .l5
.l1:    push  bc
        ld    b, a
        ld    a, (hl)
.l2:    ld    (de), a
        inc   de
        djnz  .l2
        pop   bc
.l3:    ldi
        ret   po
.l4:    ld    a, 00h                    ; *
.l5:    xor   (hl)
        cp    40h
        jr    nc, .l3
        inc   hl
        dec   bc
        dec   a
        jr    nz, .l1
        ld    a, (.l4 + 1)
        add   a, 40h
        ld    (.l4 + 1), a
        jp    .l3

; LDIR

memcpy_I:
        ld    a, c
        neg
        and   0fh
        rla
        ld    (.l1 + 1), a
.l1:    jr    .l2                       ; *
.l2:    ldi
        ldi
        ldi
        ldi
        ldi
        ldi
        ldi
        ldi
        ldi
        ldi
        ldi
        ldi
        ldi
        ldi
        ldi
        ldi
        jp    pe, .l2
        ret

; LDDR

memcpy_D:
        ld    a, c
        neg
        and   0fh
        rla
        ld    (.l1 + 1), a
.l1:    jr    .l2                       ; *
.l2:    ldd
        ldd
        ldd
        ldd
        ldd
        ldd
        ldd
        ldd
        ldd
        ldd
        ldd
        ldd
        ldd
        ldd
        ldd
        ldd
        jp    pe, .l2
        ret

